# coding: utf-8

"""
    VoiceOS

    VoiceOS API

    The version of the OpenAPI document: 0.8.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from voiceos.models.agent_configuration import AgentConfiguration
from typing import Optional, Set
from typing_extensions import Self

class CreateCall(BaseModel):
    """
    CreateCall
    """ # noqa: E501
    from_number: StrictStr = Field(description="The phone number associated with the account from which the call will be made.")
    to_number: StrictStr = Field(description="The phone number to call including the country code.")
    agent_id: Optional[StrictStr] = Field(default=None, description="The agent id to use for the conversation. If null, the agent configuration will be used.")
    agent_config: Optional[AgentConfiguration] = Field(default=None, description="The agent configuration to use for the conversation. If null, the agent id will be used.")
    __properties: ClassVar[List[str]] = ["from_number", "to_number", "agent_id", "agent_config"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateCall from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of agent_config
        if self.agent_config:
            _dict['agent_config'] = self.agent_config.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateCall from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "from_number": obj.get("from_number"),
            "to_number": obj.get("to_number"),
            "agent_id": obj.get("agent_id"),
            "agent_config": AgentConfiguration.from_dict(obj["agent_config"]) if obj.get("agent_config") is not None else None
        })
        return _obj


