# coding: utf-8

"""
    VoiceOS

    VoiceOS API

    The version of the OpenAPI document: 0.8.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Optional
from voiceos.models.azure_voice import AzureVoice
from voiceos.models.deepgram_voice import DeepgramVoice
from voiceos.models.elevenlabs_voice import ElevenlabsVoice
from voiceos.models.playht_voice import PlayhtVoice
from voiceos.models.rime_voice import RimeVoice
from typing import Union, Any, List, TYPE_CHECKING, Optional, Dict
from typing_extensions import Literal, Self
from pydantic import Field

VOICE1_ANY_OF_SCHEMAS = ["AzureVoice", "DeepgramVoice", "ElevenlabsVoice", "PlayhtVoice", "RimeVoice"]

class Voice1(BaseModel):
    """
    The synthesizer of the agent.
    """

    # data type: PlayhtVoice
    anyof_schema_1_validator: Optional[PlayhtVoice] = None
    # data type: ElevenlabsVoice
    anyof_schema_2_validator: Optional[ElevenlabsVoice] = None
    # data type: AzureVoice
    anyof_schema_3_validator: Optional[AzureVoice] = None
    # data type: DeepgramVoice
    anyof_schema_4_validator: Optional[DeepgramVoice] = None
    # data type: RimeVoice
    anyof_schema_5_validator: Optional[RimeVoice] = None
    if TYPE_CHECKING:
        actual_instance: Optional[Union[AzureVoice, DeepgramVoice, ElevenlabsVoice, PlayhtVoice, RimeVoice]] = None
    else:
        actual_instance: Any = None
    any_of_schemas: List[str] = Field(default=Literal["AzureVoice", "DeepgramVoice", "ElevenlabsVoice", "PlayhtVoice", "RimeVoice"])

    model_config = {
        "validate_assignment": True,
        "protected_namespaces": (),
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_anyof(cls, v):
        instance = Voice1.model_construct()
        error_messages = []
        # validate data type: PlayhtVoice
        if not isinstance(v, PlayhtVoice):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PlayhtVoice`")
        else:
            return v

        # validate data type: ElevenlabsVoice
        if not isinstance(v, ElevenlabsVoice):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ElevenlabsVoice`")
        else:
            return v

        # validate data type: AzureVoice
        if not isinstance(v, AzureVoice):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AzureVoice`")
        else:
            return v

        # validate data type: DeepgramVoice
        if not isinstance(v, DeepgramVoice):
            error_messages.append(f"Error! Input type `{type(v)}` is not `DeepgramVoice`")
        else:
            return v

        # validate data type: RimeVoice
        if not isinstance(v, RimeVoice):
            error_messages.append(f"Error! Input type `{type(v)}` is not `RimeVoice`")
        else:
            return v

        if error_messages:
            # no match
            raise ValueError("No match found when setting the actual_instance in Voice1 with anyOf schemas: AzureVoice, DeepgramVoice, ElevenlabsVoice, PlayhtVoice, RimeVoice. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Dict[str, Any]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        # anyof_schema_1_validator: Optional[PlayhtVoice] = None
        try:
            instance.actual_instance = PlayhtVoice.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_2_validator: Optional[ElevenlabsVoice] = None
        try:
            instance.actual_instance = ElevenlabsVoice.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_3_validator: Optional[AzureVoice] = None
        try:
            instance.actual_instance = AzureVoice.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_4_validator: Optional[DeepgramVoice] = None
        try:
            instance.actual_instance = DeepgramVoice.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_5_validator: Optional[RimeVoice] = None
        try:
            instance.actual_instance = RimeVoice.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))

        if error_messages:
            # no match
            raise ValueError("No match found when deserializing the JSON string into Voice1 with anyOf schemas: AzureVoice, DeepgramVoice, ElevenlabsVoice, PlayhtVoice, RimeVoice. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], AzureVoice, DeepgramVoice, ElevenlabsVoice, PlayhtVoice, RimeVoice]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


